* SPKA code   (Vers. 6C)
* 
*
* Command: spkaNN.exe  <output.XXX>  <NNN>
*
*   NN: version of spka code
*   output.XXX: "output" file from NJOY
*   NNN: if omitted, the file name or the group number will be inquired
*        if exists = is the number of the group ONLY. To get this number 
*        open "output" file from NJOY and find the number of 
*        corresponding neutron group
*
*
* Author: S.P.Simakov 
*
*
*
* nderungen: AK    03.06.2015 
*
*
*************************************************************************
*
       PROGRAM SPKA
C      ==============
      character FLNM*25,FLNMs*25,line*500,linex*30,ar(6)*11
      character*11 a1,a2,a3,a4,a5,a6
      Character Name1*500,spkares*500,c500*500,name2*25
      Common/Name/Name1
      Common/idruck/idruck
      Common/icount/icount
      Common/Juni2/DistARob(301),DistAMD(301)
      Common/izreciarec/izrec,iarec
*
      parameter igr=187, imtmax=150
      DIMENSION EnL(igr),EnR(igr),EgL(42),EgR(42),MT(imtmax),xS(igr)
        dimension R(imtmax,igr,igr),Rcollapse(imtmax,igr),Rsum(igr),
     c  Sgr(igr)
        dimension RcollapseRob(imtmax,igr),RsumRob(igr)
        dimension RcollapseMD(imtmax,igr),RsumMD(igr)
        dimension Snmt(imtmax),MTD(1111)
	dimension E(25000),s(25000),es(25000),ss(25000)
	logical exst
                                   do i=1,1111;MTD(i)=9999;enddo
*
*------------------- P R I N T   O P T I O N S -------------------------
*
* I. Print option for different MT 
*
*    The total spectum will be printed anyway.
* to print spectra for all MTs       :  MTD(1)=-9999
* to print spectra for all MTs 
*     without MT=51-90               :  MTD(1)=-1
* to print spectra for all MTs 
*     without MT=51-90 and MT >= 600 :  MTD(1)=-2
* to print nothing except total      :  MTD(1)=0
* Example. MTD(1)=2; MTD(2)=16 means the printing only for total,
*          elastic and (n,2n)
*
        MTD(1)=-2
*
* II. Print option for spectra
*
*     =1: only recoil spectra
*     =2: in addition to "1" spectra multiplied on the damage energy 
*           (Robinson function)
*     =3: in addition to "2" spectra obtained using BCA-MD
*            (in the current version only for Fe, look all *Fe lines
*
      idruck=3
*
*----------------------------------------------------------------------
*
      write(*,4); icount=0
      name1=' '; call getarg(1,name1); if(name1.eq.' ')goto 92000
      name2=' '; call getarg(2,name2); 
*
      Call Namen_Output_Datei(-2,spkares,k1,MT)
      open(333,file=spkares(1:k1)); Write(333,5)  ! Info
*
      Do i=1,301; DistARob(i)=0.0; DistAMD(i)=0.0; Enddo
      Call Namen_Output_Datei(-1,spkares,k1,MT)
      open(15,file=spkares(1:k1));  
      do i=1,imtmax
        do j=1,igr
          Rsum(j)=0.; RsumRob(j)=0.; RsumMD(j)=0.
            Rcollapse(i,j)=0.; RcollapseRob(i,j)=0.; RcollapseMD(i,j)=0.
              do l=1,igr; R(i,j,l)=0.; enddo; enddo; enddo
*
      if(name2.ne.' ')then; flnm=name2;goto 99; endif
*
1234	write(*,*)
*
      Write(*,1235)
      read(*,1) flnm
   99  call check_flnm(flnm,key,name1,sgr,nsgr)
       if(key.eq.0) then; 
                       keygr=1
                          goto 3000 !  nur die Gruppennumer ist gegeben
                    endif
*
*
      if(index(flnm,'.').eq.0) then
 	  ln=len_trim(flnm)+1
c       flnms(1:8)=flnm(1:ln)
        flnm(ln:)='.dat'
                               endif                        
	inquire(file=flnm,exist=exst)
	if(.not.exst) then
	  write(*,*)' File does not exist ! Please try once again !'
        write(*,*)
        goto 1234
                      endif
*AK!	write(*,*) ' Energy increases (if for FISPACT then 0)    ? (1/0)'
*      read(*,3) keygr
       keygr=1
*
        i=0
	open(3,file=flnm,status='OLD')
301     i=i+1
              if(i.gt.igr) then
                   Write(*,*)igr,' ist zu wenig !'
                             pause;stop;endif
	  if(keygr.eq.0) then
	    read(3,*,end=300) (Sgr(i),i=1,175)
	    go to 300
	  else
	    read(3,*,end=300) Sgr(i)
          go to 301
	  endif
300	close(3)
	nSgr=i-1
cccc	nsgr=175
*
*
3000    Sum=0.; do i=1,nSgr;  Sum=Sum+Sgr(i); xS(i)=Sgr(i); enddo
*
	if(keygr.eq.0) then
          do i=1,nSgr; Sgr(nSgr-i+1)=xS(i); enddo
	endif
*
	write(15,303) flnm,nSgr,Sum
        open(1,file=name1,status='OLD',err=91000)
                         If(idruck.eq.1) Write(333,*)
                         if(idruck.ge.2) Call find_important_information
*
	rewind(1)
	do i=1,40
         READ(1,520,end=510) line
         write(15,520) line
	enddo
*
1111    continue
      READ(1,520,end=510) line
        if(line(1:10).ne.' groupr...') go to 1111
	write(15,590)
	write(15,520) line

c  -------- Reading Group	Edges --------
2222  READ(1,520,end=510) line
        if(line(1:25).ne.' neutron group structure.') go to 2222
	write(15,590)
	write(15,520) line
*AK	read ( 1,521) (I,EnL(I),EnR(I),I=1,nSgr)
	read ( 1,521) (ixxx,EnL(I),EnR(I),I=1,nSgr)
	write(15,521) (I,EnL(I),EnR(I),I=1,nSgr)
      
3333  READ(1,520,end=510) line
        if(line(1:25).ne.' gamma group structure...') go to 3333
	write(15,590)
	write(15,520) line
*AK	read ( 1,521) (I,EgL(I),EgR(I),I=1,42)
	read ( 1,521) (ixxx,EgL(I),EgR(I),I=1,42)
        write(15,521) (I,EgL(I),EgR(I),I=1,42)  ! AK
c ------  Reading: Cycle over MT ---------	
	nMT=0
4444  READ(1,520,end=510) line
        if(line(1:7).ne.' for mf') go to 4444
	write(15,590)
	write(15,520) line
                     read(line(18:20),*) MTtmp; if(MTtmp.eq.5) goto 4444
        nMT=nMT+1; if(nmt.gt.imtmax) goto 93000
*
	read(line(18:20),*) MT(nMT)

	write(15,524) nMT,MT(nMT)
	do i=1,4
         READ(1,520,end=510) line
	enddo
c  ------  Reading Recoil Matrix for specific MT ------
8887	read(1,520) line
            C500='norm'; Call Finden(line,C500,4,iposi)
            if(iposi.ne.0) read(1,520)line
        if(len_trim(line).le.2) go to 4444
	read(line(1:6) ,*) Ni   ! *AK
	read(line(7:13),*) Nf   ! *AK
*
	linelength=len_trim(line(15:))  ! *AK
      nar=linelength/11                         ! number of entries per line
*
	do i=1,nar
        n1=15+11*(i-1); n2=15+11*i
        if(n1.gt.500.or.n2.gt.500) then;Write(*,*)' 500 ist zu wenig !'
                                   pause;stop;endif           
         read(line(15+11*(i-1):15+11*i),*) ar(i)  ! read particular entry          ! *AK
	 ipos=index(ar(i)(6:10),'-')              ! searching the postion of '-' 
	 if(ipos.eq.0)ipos=index(ar(i)(6:11),'+') ! if not '-' then searching '+'
	 ipos=ipos+5
	 ipos1=ipos-1
	 read(ar(i)(1:ipos1),*) xdez
	 read(ar(i)(ipos:11),*) xexp
	 R(nMT,Ni,Nf+i-1)=xdez*10**xexp
	 if(R(nMT,Ni,Nf+i-1).lt.0)then
	    write(15,*)'Negative Recoil for MT',MT(nmt)
	    write(15,*)'nMT',nMT,'Ni,Nf=',Ni,Nf,'R=',R(nMT,Ni,Nf+i-1)
       endif
251	continue
	enddo
*
	go to 8887
*
*        
c --------  Collapsing with Energy Neutron Flux ------
*
510	nMTmax=nMT
        Do 333 nMT=1,nMTmax
                            MTlauf=MT(nMT)
                       if(idruck.ge.2) Call def(0.0,MTlauf,CFNJ,CFEFF)
* 
        if(MT(nmt).ge. 51.and.MT(nmt).le. 91)  na=1    ! MT=4
        if(MT(nmt).ge.600.and.MT(nmt).le.649)  na=2    ! MT=103
        if(MT(nmt).ge.650.and.MT(nmt).le.699)  na=3    ! MT=104
        if(MT(nmt).ge.700.and.MT(nmt).le.749)  na=4    ! MT=105
        if(MT(nmt).ge.750.and.MT(nmt).le.799)  na=5    ! MT=106
        if(MT(nmt).ge.800.and.MT(nmt).le.849)  na=6    ! MT=107
*
           Do 222 nf=1,nSgr
               Do 111 ni=1,nSgr
  111             Rcollapse(nMT,nf)=Rcollapse(nMT,nf)
     &                           +Sgr(ni)*R(nMT,ni,nf)/Sum
*
           if(idruck.ge.2)then
           ee=0.5*(EnL(nf)+EnR(nf)) 
                              Call def(ee,MTlauf,CFNJ,CFEFF)
                  RcollapseRob(nMT,nf)=CFNJ*Rcollapse(nMT,nf); 
                          endif
           if(idruck.eq.3)
     c            RcollapseMD(nMT,nf)=CFEFF*Rcollapse(nMT,nf); 
*
* MT=51-91 und 600-849
       If( (MT(nmt).ge. 51.and.MT(nmt).le. 91).or.
     c     (MT(nmt).ge.600.and.MT(nmt).le.849) )  Then
       Rcollapse(nMTmax+na,nf)=Rcollapse(nMTmax+na,nf)+Rcollapse(nMT,nf)
        if(idruck.ge.2)
     c RcollapseRob(nMTmax+na,nf)=RcollapseRob(nMTmax+na,nf)+
     c                            RcollapseRob(nMT,nf)
        if(idruck.eq.3)
     c RcollapseMD(nMTmax+na,nf)=RcollapseMD(nMTmax+na,nf)+
     c                            RcollapseMD(nMT,nf)

                                                  Endif
*
	      Rsum(nf)=Rsum(nf)+Rcollapse(nMT,nf)
              RsumRob(nf)=RsumRob(nf)+RcollapseRob(nMT,nf)
              RsumMD(nf)=RsumMD(nf)+RcollapseMD(nMT,nf)
        If(idruck.ge.2) 
     c    DistARob(iarec)=DistARob(iarec)+RcollapseRob(nMT,nf)
*
        If(idruck.ge.3) 
     c    DistAMD(iarec)=DistAMD(iarec)+RcollapseMD(nMT,nf)
*
*
  222      Continue
*
  333   Continue
*
                          if((nMTmax+6).gt.imtmax) goto 90000
* No problem, if for example, MT=103 appears before, in that case 
*  new "nMTmax+na" array data = 0
        MT(nMTmax+1)=4
        MT(nMTmax+2)=103
        MT(nMTmax+3)=104
        MT(nMTmax+4)=105
        MT(nMTmax+5)=106
        MT(nMTmax+6)=107
*
*
c  -------  Printing Collapsed PKA for MT ---------
        write(15,591); write(15,590)
*
* here "nMTmax+1" change it for "+6" if necessary
        write(15,526) (MT(nMT),nMT=1,nMTmax+1); write(15,528)
*
	do nf=1,nSgr
	   write(15,527) EnL(nf),EnR(nf),Sgr(nf)/Sum,Rsum(nf),
     &                 (Rcollapse(nmt,nf),nmt=1,nMTmax+1)
	enddo
	write(15,528)
        xsum=0;  xrsum=0; do i=1,nMTmax+1;   Snmt(i)=0.; enddo
*
	do nf=1,nSgr
            xsum=xsum+sgr(nf)/sum;  xrsum=xrsum+rsum(nf)
	  do nmt=1,nMTmax+1
	     Snmt(nmt)=Snmt(nmt)+Rcollapse(nmt,nf)
	  enddo 
	enddo
      write(15,529) xsum,xrsum,(Snmt(nmt),nmt=1,nMTmax+1)
      write(15,539) xsum,100*xrsum/xrsum,
     &                         (100*Snmt(nmt)/xrsum,nmt=1,nMTmax+1)
	write(15,528)
*
        write(15,1591); write(15,590)
        write(15,526) (MT(nMT),nMT=1,nMTmax+1); write(15,528)
	do nf=1,nSgr
	   de=(EnR(nf)-EnL(nf))/1.E+6
	   write(15,527) EnL(nf),EnR(nf),Sgr(nf)/Sum/de,Rsum(nf)/de,
     &                 (Rcollapse(nmt,nf)/de,nmt=1,nMTmax+1)
	enddo
	write(15,528)
*
        xsum=0;  xrsum=0;  do i=1,nMTmax+1; Snmt(i)=0.; enddo
*
	do nf=1,nSgr
            xsum=xsum+sgr(nf)/sum;  xrsum=xrsum+rsum(nf)
          do nmt=1,nMTmax+1
	     Snmt(nmt)=Snmt(nmt)+Rcollapse(nmt,nf)
	  enddo 
	enddo
      write(15,529) xsum,xrsum,(Snmt(nmt),nmt=1,nMTmax+1)
	write(15,528)
      close(1); close(15)
*
*
*AK
* total spectrum
* ==============
      Call Druck_Spectra(0, EnL,EnR,MT,Rcollapse,Rsum,Sgr,nsgr,
     c                   RcollapseRob,RsumRob,RcollapseMD,RsumMD)
*
*
*
      If(MTD(1).eq.0) stop
*
      Do 7000 nmt=1,nmTmax+6
*
      if(MTD(1).eq.-9999) goto 5555
      if(MTD(1).eq.-1) then
        if(MT(nmt).lt.51.or.MT(nmt).gt.90) then; goto 5555
                                           else; goto 7000; endif;endif
      if(MTD(1).eq.-2) then
        if((MT(nmt).lt.51.or.MT(nmt).gt.90).and.MT(nmt).lt.600) then
                                                 goto 5555
                                           else; goto 7000; endif;endif
      do imt=1,1111
      if(MTD(imt).eq.MT(nmt)) goto 5555
      enddo; goto 7000
*
 5555 Call Druck_Spectra(nmt, EnL,EnR,MT,Rcollapse,Rsum,Sgr,nsgr,
     c                   RcollapseRob,RsumRob,RcollapseMD,RsumMD)
*
 7000 Continue
*
*
      Stop
*
*
1     Format(A25)
2     Format(F10.4)
3     Format(I6)
4     Format(1x,51('-')/t11,'SPKA: version of May 2015'/
     c'    PKA Spectra extraction from NJOY/Groupr output'/
     ct10,'Command line: spka.exe njoy_output_file'/1x,51('-'))
5     Format('Integrated recoil spectra dS/dT'/31('*'))
303   Format(/'  Neutron Group Spectrum File =',A16
     &/'  Number of groups = 'I6',   Sum =',1p,E12.5/)
520   Format(A500)
521   Format(I6,1x,1p,E13.5,3x,E13.5)
524   Format(' nMT, MT ='2I6)   
526   Format(7x,'Eleft  -   Eright'6x'Sgroup'8x'Rsum   R/MT='I4,49I12)
527   Format(1p,2E12.4,51E12.5)
528   Format(100('-'))
529   Format('   Summ'17x,1p,51E12.5)
539   Format('      %'17x,1p,51E12.3)
590   Format(50('-'))
591   Format(/68('*')//
     c' (!) Attention. Data below contains MT=51-... and MT=4 ',
     c'(last one)'//68('*')//
     c' Recoil Matrix [b/bin] Collapsed with Neutron Spectrum'/)
1235  Format(' File NAME  with Grouped Neutron Spectrum (def=.dat)  '
     c  /'     or'/
     c ' the number of single group defining initial neutron energy')
1591  Format(/' Recoil Matrix [b/MeV] Collapsed with Neutron Spectrum'/)
90000 Write(*,90001),imtmax,(nMTmax+6)
90001 Format('imtmax=',i6,' is too small ! It should be at least ',i5/)
      pause;stop
91000 Write(*,91001)name1(1:40) 
91001 format(//' The following file does not exist:'/a40//)
      pause;stop
92000 write(*,*)
      Write(*,*)' The input file with NHOY Output is not found !'
      write(*,*);pause;stop
93000 Write(*,93001),imtmax           
93001 Format('imtmax=',i6,' is too small !!'/)                         
      pause;stop
      END
*
***********************************************************************
      Subroutine Druck_Spectra(MT0,EnL,EnR,MT,Rcollapse,Rsum,Sgr,nsgr,
     c                         RcollapseRob,RsumRob,RcollapseMD,RsumMD)
      parameter igr=187, imtmax=150
      Character C6*6,CN*500,C17a*17,C17b*17,C17c*17
      Common/idruck/idruck
      Common/icount/icount
      Common/Juni2/DistARob(301),DistAMD(301)
      DIMENSION EnL(igr),EnR(igr),MT(imtmax)
      dimension Rcollapse(imtmax,igr),Rsum(igr),Sgr(igr)
      dimension RcollapseRob(imtmax,igr),RsumRob(igr)
      dimension RcollapseMD(imtmax,igr),RsumMD(igr)
      Dimension Druck(igr),DruckRob(igr),DruckMD(igr)
                                          icount=icount+1
      if(MT0.eq.0) Then
                      C6=' Total'
                      do i=1,igr; Druck(i)=Rsum(i); enddo
      if(idruck.ge.2) then
                      do i=1,igr; DruckRob(i)=RsumRob(i); enddo
                      endif
      if(idruck.eq.3) then
                      do i=1,igr; DruckMD(i)=RsumMD(i); enddo
                      endif
                   Else
                      C6='MT=nnn'
                      Write(C6(4:6),'(i3)')MT(MT0)       
                      do i=1,igr; Druck(i)=Rcollapse(MT0,i);enddo
      if(idruck.ge.2) then
                      do i=1,igr; DruckRob(i)=RcollapseRob(MT0,i);enddo
                      endif
      if(idruck.eq.3) then
                      do i=1,igr; DruckMD(i)=RcollapseMD(MT0,i);enddo
                      endif
                   Endif
*
      do i=1,nsgr; if(Druck(i).ne.0.0) goto 3; enddo
      Return  ! nothing to print, all data = 0.0 
*
    3 Call Namen_Output_Datei(MT0,CN,K1,MT)
      open(900,file=CN(1:k1))
*
*
       do nf=nsgr,1,-1; nmax=nf; if(Druck(nf).gt.0.0) goto 1; enddo
    1  do nf=1,nsgr;    nmin=nf; if(Druck(nf).gt.0.0) goto 2; enddo
    2  nmin=nmin-1;if(nmin.le.0) nmin=1
*
        Write(900,'(a9,a6,a18)')'"        ',C6,' recoil spectrum "'
        Write(900,800);  if(icount.eq.1) Write(333,801)
*
        Do nf=1,nsgr
        if(sgr(nf).ne.0.0) then
          Write(900,999)'"',EnL(nf)/1.e+6,' - ',EnR(nf)/1.e+6,'  MeV"'
          if(icount.eq.1)
     c    Write(333,998)EnL(nf)/1.e+6,' - ',EnR(nf)/1.e+6,'  MeV'
                           endif
        Enddo
        Write(900,'(a)')'"'
                   Summe1=0.0; Summe2=0.0; Summe3=0.0
*
*
      If(idruck.eq.1) then                                        ! 1)
      Write(900,1000)
      Do nf=nmin,nmax
	   de=(EnR(nf)-EnL(nf))/1.E+6
      C1=' '; if(Druck(nf).eq.0.0)C1='"'
      Write(900,1001)C1,EnL(nf)/1.e+6,Druck(nf)/de
      Write(900,1001)C1,EnR(nf)/1.e+6,Druck(nf)/de
                          Summe1=Summe1+Druck(nf)
      Enddo
                      endif                                       ! 1)
*
      If(idruck.ge.2)                                       THEN  ! 2)
                            if(idruck.eq.2) Write(900,2000)
                            if(idruck.eq.3) Write(900,3000)
      Do nf=nmin,nmax
	   de=(EnR(nf)-EnL(nf))/1.E+6
*
      Write(C17a,'(1pe17.5)')Druck(nf)/de
      if(Druck(nf).le.0.0) then;C17a(6:6)='"';C17a(17:17)='"';endif
*
      Write(C17b,'(1pe17.5)')DruckRob(nf)/de
      if(DruckRob(nf).le.0.0) then;C17b(6:6)='"';C17b(17:17)='"';endif
*
      if(idruck.eq.2) then 
      Write(900,2001)EnL(nf)/1.e+6,C17a,C17b
      Write(900,2001)EnR(nf)/1.e+6,C17a,C17b
                      endif 
          Summe1=Summe1+Druck(nf)
          Summe2=Summe2+DruckRob(nf)
*
      if(idruck.eq.3) then 
      Write(C17c,'(1pe17.5)')DruckMD(nf)/de
      if(DruckMD(nf).le.0.0) then;C17c(6:6)='"';C17c(17:17)='"';endif
      Write(900,3001)EnL(nf)/1.e+6,C17a,C17b,C17c
      Write(900,3001)EnR(nf)/1.e+6,C17a,C17b,C17c
          Summe3=Summe3+DruckMD(nf)
                      endif 
      Enddo
                                                            ENDIF ! 2)
*
      If(MT0.eq.0)                                      THEn
*
*
* E-Verteilung
* ------------
      Call Namen_Output_Datei(-3,CN,K1,MT)
      open(901,file=CN(1:k1))
                   Summe2e=0.0; Summe3e=0.0
      Do nf=nmin,nmax
          Summe2e=Summe2e+DruckRob(nf)
          Summe3e=Summe3e+DruckMD(nf)
      s2=0.0; s3=0.0;
      if(Summe2.ne.0.0) s2=Summe2e/Summe2
      if(Summe3.ne.0.0) s3=Summe3e/Summe3
*
      Write(901,'(3g14.5)')0.5*(EnL(nf)+EnR(nf))/1.e+6,S2,S3 
      Enddo
      close(901)
*
*
* A-Verteilung (1)
* - - - - - - - - -
* Output "DisA_XXX.dat" : growing integral with A
*
      Call Namen_Output_Datei(-4,CN,K1,MT)
      open(901,file=CN(1:k1))
                   Summe2a=0.0; Summe3a=0.0
      Do ia=1,301
      iamin=ia-1
      If(DistARob(ia).gt.0.0) goto 1111 
      Enddo        
 1111 if(iamin.lt.1) iamin=1
                                              call maxa(iamax)
                             if(iamin.gt.iamax) call fehler(20150603)
      Do ia=iamin,iamax
          Summe2a=Summe2a+DistARob(ia)
          Summe3a=Summe3a+DistAMD(ia)
      s2=0.0; s3=0.0;
      if(Summe2.ne.0.0) s2=Summe2a/Summe2
      if(Summe3.ne.0.0) s3=Summe3a/Summe3
*
      aa=ia
      Write(901,'(3g14.5)')aa-0.5,S2,S3 
      Write(901,'(3g14.5)')aa+0.5,S2,S3 
      Enddo
      close(901)
*
*
* A-Verteilung (2)
* - - - - - - - - -
* Output "DiAC_XXX.dat" : simply realtive contributions 
*
      Call Namen_Output_Datei(-5,CN,K1,MT)
      open(901,file=CN(1:k1))
*
      Do ia=iamin,iamax
      s2=0.0; s3=0.0;
      if(Summe2.ne.0.0) s2=DistARob(ia)/Summe2
      if(Summe3.ne.0.0) s3=DistAMD(ia)/Summe3
*
      aa=ia
      if(ia.eq.iamin) then
          Write(901,'(3g14.5,a22)')aa-0.5,S2,S3,' relative contribution'
          Write(901,'(3g14.5    )')aa+0.5,S2,S3
                      else
          Write(901,'(3g14.5)')aa-0.5,S2,S3 
          Write(901,'(3g14.5)')aa+0.5,S2,S3 
                      endif
      Enddo
      close(901)
                                                        ENDIf
* 
*
*
      Call Druck_Integrierte_Werte(C6,Summe1,Summe2,Summe3)
*
      close(900)
      Return
  800 Format('" Initial neutron energy corresponds to the group:"')
  801 Format(' Initial neutron energy corresponds to the group:')
  998 Format(1pe18.5,a3,e12.5,a6/)
  999 Format(a1,1x,1pe12.5,a3,e12.5,a6)
 1000 Format('"Energy (MeV)  Recoil spectrum (b/MeV)"') 
 1001 Format(a1,1pe12.5,e17.5)
 2000 Format('" A: Energy (MeV)'/'" B: Recoil spectrum (b/MeV)'/
     c'" C: Recoil spectrum multiplied on the damage energy (eV*b/MeV)'/
     c'"'/'"     A',17x,'B',17x,'C')
 2001 Format(1x,1pe12.5,2a17)
 3000 Format('" A: Energy (MeV)'/'" B: Recoil spectrum (b/MeV)'/
     c'" C: Recoil spectrum multiplied on the damage energy (eV*b/MeV)'/
     c'" D: Recoil spectrum multiplied on the damage energy corrected ',
     c'using BCA-MD (eV*b/MeV)'/
     c'"'/'"     A',17x,'B',17x,'C',17x,'D')
 3001 Format(1x,1pe12.5,3a17)
      End
*
***********************************************************************
      Subroutine Druck_Integrierte_Werte(C6,Summe1,Summe2,Summe3)
      Character C6*6
      Common/ZpApZtAtEd/Ed,IZP,IAP,IZT,IAT
      Common/idruck/idruck
      Common/Juni/XSdpaTOT,XSdpaMDTOT
*
      Write(333,1000)C6 
      Write(333,1001)Summe1
                           if(idruck.eq.1) goto 8888        
      Write(333,1002)Summe2
                     XSdpa=Summe2*0.8/(2.*Ed)
      Write(333,1003)XSdpa
         If(C6.ne.' Total') Write(333,10031)100.*XSdpa/XSdpaTOT
*
                           if(idruck.eq.2) goto 8888        
      Write(333,1004)Summe3
                     XSdpaMD=Summe3*0.8/(2.*Ed)
      Write(333,1005)XSdpaMD
         If(C6.ne.' Total') Write(333,10031)100.*XSdpaMD/XSdpaMDTOT
*
*
 8888 Write(333,'(/)')
*
                                    If(C6.ne.' Total')Return
      XSdpaTOT=XSdpa
      XSdpaMDTOT=XSdpaMD
      Return
*
*
 1000 Format(a6/6('-'))
 1001 Format(' Integrated recoil spectrum:',1pe14.6,'  (barn)')
 1002 Format(/' Int dS/dT multiplied on Robinson damage energy :',
     c 1pe14.6,'  (ev*barn)')
 1003 Format(' Displacement cross-section (with 0.8/2Ed)      :',
     c f9.1,'       (barn)')
10031 Format(t52,'(',f6.2,' % of total)')
*
 1004 Format(/' Int dS/dT with BCA-MD efficiency               :',
     c1pe14.6,'  (ev*barn)')
 1005 Format(' Displacement cross-section, BCA-MD             :',
     c f9.1,'       (barn)')
      End
*
***********************************************************************
       Subroutine check_flnm(flnm,key,name1,Sgr,nsgr)
       character FLNM*25,c*60,name1*500, Zeile*500
       parameter igr=187
       dimension Sgr(igr)
       C='qwertzuiopQWERTZUIOPasdfghjklASDFGHJKLyxcvbnmYXCVBNM_.'
                               key=1
       Do i=1,25
          do j=1,60
       if(flnm(i:i).eq.C(j:j)) Return
       Enddo;enddo
*
                               key=0
* nimm SGR jetzt
       open(899,file=name1,status='old',err=90000)
1111   Read(899,'(a500)',end=91000)Zeile
       If(Zeile(1:29).ne.' neutron group structure.....') goto 1111
*
2222   Read(899,'(a500)',end=92000)Zeile
       Read(Zeile(1:6),'(i6)')n
        if(n.ne.0) then
                      nsgr=n
              if(nsgr.gt.igr) then
                   Write(*,*)igr,' ist zu wenig !'
                             pause;stop;endif
                        goto 2222; endif
       Read(flnm,*)Nicht_null
         if(Nicht_null.gt.nsgr) goto 93000
*
       do i=1,nsgr
       sgr(i)=0.0
       enddo
*
       Sgr(nicht_null)=1.0
*
*
       close(899)
       Return
* 
90000  Print 90001,name1(1:50)
90001  Format(/'Die folgende Datei :'/a50/' existiert NICHT !'//)
       pause;stop
91000  Print 91001,name1(1:50)
91001  Format(/'in der folgenden Datei :'/a50/
     c 'die Phrase " neutron group structure....." NICHT gefunden!'//)
       pause;stop
92000  Print 92001,name1(1:50)
92001  Format(/'Problem (1) mit der folgenden Datei :'/a50//)
       pause;stop
93000  Print 93001,Nicht_null,nsgr
93001  Format(/' Die geforderte Gruppe=',i4,' ist nicht fuer die '/
     c 'vorhandene Spectrum-Struktur geeignet (max=',i4//)
       pause;stop
       End
*
***********************************************************************
      Subroutine Namen_Output_Datei(MT0,CN,K1,MT)
      parameter imtmax=150
      Character Name1*500,CN*500,C4*4
      Common/Name/Name1
      Dimension MT(imtmax)
      C4='.dat' 
                    CN='_____'
      if(MT0.eq.-5) then
                    CN='diAC_'
                    endif
      if(MT0.eq.-4) then
                    CN='disA_'
                    endif
      if(MT0.eq.-3) then
                    CN='disE_'
                    endif
      if(MT0.eq.-2) then
                    CN='info_';C4='.txt' 
                    endif
      if(MT0.eq.-1) then
                    CN='spka_';C4='.res' 
                    endif
      if(MT0.eq. 0) CN='r_Sp_'
      if(MT0.gt. 0) Write(CN(1:4),'(i4)')MT(MT0)
*
      do i=1,500;  if(name1(i:i).eq.'.') then
      CN(6:500)=name1((i+1):(i+12))
                    goto 1; endif;   enddo 
    1 CN(477:500)=C4; call entluecken(CN,k1)
      Return
      End   
*
***********************************************************************
      Subroutine ENTLUECKEN(C500,iletzte)
      Character C500*500, CTMP*500; ctmp=' ';j=0;do 2 i=1,500
      if(C500(i:i).eq.' ') goto 2;j=j+1; ctmp(j:j)=c500(i:i);
   2  continue; c500=ctmp; iletzte=j; return
      end 
*
***********************************************************************
      Subroutine find_important_information
      Common/ZpApZtAtEd/Ed,IZP,IAP,IZT,IAT
      Common/idruck/idruck
      Character C*500
*
* From tape20: nur IZP,IAP,IZT,IAT
*
      open(99,file='tape20',status='old',err=90000)
         read(99,*)
      Read(99,'(1e11.0,t67,i4,i2,i3)',err=91000,end=91000)ZA,MAT,MF,MT
      If(MF.ne.1.or.MT.ne.451) goto 91000  
         read(99,*)
      Read(99,'(t45,i11)',err=91000,end=91000)NSUB
      close(99)
        IZA=ifix(ZA+0.0001);IZT=IZA/1000;  IAT=mod(IZA,1000)
        NPAR=NSUB/10;  IZP=NPAR/1000;  IAP=mod(NPAR,1000)
        If(IZP.ne.0.or.IAP.ne.1) goto 92000 
*************
*Fe
        if(idruck.eq.3.and.IZT.ne.26) idruck=2
*************
*
      do while(.not.eof(1))
      Read(1,'(a500)')C
      If(C(1:38).eq.' damage displacement energy ..........') goto 1
      enddo
      call fehler(3001)
    1 if(C(44:50).ne.'default') then
                                    Read(C(44:50),*,err=3002)Ed
                                else
      do while(.not.eof(1))
      Read(1,'(a500)')C
      If(C(1:24).eq.' default damage energy =') goto 2
      enddo
      call fehler(3003)
   2                                Read(C(25:30),*,err=3004)Ed
                                 endif
      rewind 1       
*
* "neue" MT
* only for primary neutrons
      Call lesen_neue_MT
*
      Write(333,1000)Ed
      Return
*
 1000 Format(t57,'Ed=',f5.1,' eV')
 3002 call fehler(3002)
 3004 call fehler(3004)
90000 Write(*,90001)
90001 format(//' The file "tape20" does not exist!'/)
      pause;stop
91000 Write(*,91001)
91001 format(//' The file "tape20" is wrong !'/)
      pause;stop
92000 Write(*,92001)
92001 format(//' For other than NEUTRON projectiles change Subroutine "l
     cesen_neue_MT" !')
      call fehler(1234)
      end 
*
***********************************************************************
      Subroutine maxa(iamax)
      Common/ZpApZtAtEd/Ed,IZP,IAP,IZT,IAT
      iamax=iat+iap
      Return
      end 
*
***************************************************************************
        Subroutine lesen_neue_MT
        Character R(1001)*80
* einfach die Reaktion und MT. die Zahl der Lcken ist egal
* ! nur primre Neutronen sind erlaubt
*
* EAF MT numbers
        R( 1)=' (n,2nd)  11   '; R(33)='(n,5nd) 170    ';
        R( 2)=' (n,n3a)  23   '; R(34)='(n,6nd) 171    ';
        R( 3)=' (n,2n2a) 30   '; R(35)='(n,3nt) 172    ';
        R( 4)=' (n,nd2a) 35   '; R(36)='(n,4nt) 173    ';
        R( 5)=' (n,nt2a) 36   '; R(37)='(n,5nt) 174    ';
        R( 6)=' (n,3np)  42   '; R(38)='(n,6nt) 175    ';
        R( 7)=' (n,n2p)  44   '; R(39)='(n,2nh) 176    ';
        R( 8)=' (n,npa)  45   '; R(40)='(n,3nh)  177   ';
        R( 9)=' (n,3a)   109  '; R(41)='(n,4nh)  178   ';
        R(10)=' (n,t2a)  113  '; R(42)='(n,3n2p) 179   ';
        R(11)=' (n,d2a)  114  '; R(43)='(n,3n2a) 180   ';
        R(12)=' (n,pd)   115  '; R(44)='(n,3npa) 181   ';
        R(13)='(n,pt)   116   '; R(45)='(n,dt)   182   ';
        R(14)='(n,da)   117   '; R(46)='(n,npd)  183   ';
        R(15)='(n,5n)   152   '; R(47)='(n,npt)  184   ';
        R(16)='(n,6n)   153   '; R(48)='(n,ndt)  185   ';
        R(17)='(n,2nt)  154   '; R(49)='(n,nph)  186   ';
        R(18)='(n,ta)   155   '; R(50)='(n,ndh)  187   ';
        R(19)='(n,4np)  156   '; R(51)='(n,nth)  188   ';
        R(20)='(n,3nd)  157   '; R(52)='(n,nta)  189   ';
        R(21)='(n,nda)  158   '; R(53)='(n,2n2p) 190   ';
        R(22)='(n,2npa) 159   '; R(54)='(n,ph)   191   ';
        R(23)='(n,7n)   160   '; R(55)='(n,dh)   192   ';
        R(24)='(n,8n)   161   '; R(56)='(n,ha)   193   ';
        R(25)='(n,5np)  162   '; R(57)='(n,4n2p) 194   ';
        R(26)='(n,6np)  163   '; R(58)='(n,4n2a) 195   ';
        R(27)='(n,7np)  164   '; R(59)='(n,4npa) 196   ';
        R(28)='(n,4na)  165   '; R(60)='(n,3p)   197   ';
        R(29)='(n,5na)  166   '; R(61)=' (n,n3p)  198  ';
        R(30)='(n,6na)  167   '; R(62)=' (n,3n2pa) 199 ';
        R(31)='(n,7na)  168   '; R(63)='  (n,5n2p) 200 ';
        R(32)='(n,4nd)  169   ';
        NMT=63
                           Call MT_Interpretieren(R,NMT)
        Return
        End
*
***************************************************************************
        Subroutine MT_Interpretieren(R,NMT)
        Character R(1001)*80
        Common/Reaktion/MTZUS(999,6)
        Dimension NZahl(6)
* 1= n, 2= p, 3=d, 4=t, 5=3He, 6=a
            Do 1 i=1,999; Do 1 j=1,6
    1       MTZUS(i,j)=0
       Do i=1,NMT 
          Call Uebersetzen_die Reaktion(R(i),Nzahl,mt)
          do j=1,6;  MTZUS(mt,j)=NZahl(j);   enddo
       Enddo
       Return
       End
*
**************************************************************************
         Subroutine Uebersetzen_die Reaktion(Zeile,Nzahl,MT)
         Character Zeile*80, CTMP*80,CC*500
         Dimension NZahl(6)
* 1= n, 2= p, 3=d, 4=t, 5=h, 6=a
* z.B. (n,3nta)
                            Call Translate1(Zeile)
         CC=Zeile; Call ENTLUECKEN(CC,iletzte); Zeile=CC(1:80)
         do i=1,80
         icomma=i+1
         if(Zeile(i:i).eq.',') goto 1
         enddo
                                          call fehler(50000)
    1    do i=icomma,80
         iklam2=i-1
         if(Zeile(i:i).eq.')') goto 2
         enddo
                                          call fehler(50001)
    2   Continue
        Call Finden_NPDTHA(Zeile,icomma,iklam2,'n',Nzahl(1))
        Call Finden_NPDTHA(Zeile,icomma,iklam2,'p',Nzahl(2))
        Call Finden_NPDTHA(Zeile,icomma,iklam2,'d',Nzahl(3))
        Call Finden_NPDTHA(Zeile,icomma,iklam2,'t',Nzahl(4))
        Call Finden_NPDTHA(Zeile,icomma,iklam2,'h',Nzahl(5))
        Call Finden_NPDTHA(Zeile,icomma,iklam2,'a',Nzahl(6))
         iklam3=iklam2+1
        CTMP=Zeile
        do i=1,iklam3; CTMP(i:i)=' '; enddo; Read(CTMP,*)MT
        Return
        End
*
**************************************************************************
        Subroutine Finden_NPDTHA(Zeile,icomma,iklam2,C,Nzahl)  
        Character Zeile*80, Z*10, Ztmp*100, Ztmp2*100, C*1
         Z='1234567890'
*              ","+1   ")"-1
         do i=icomma,iklam2
         is=i
         if(Zeile(i:i).eq.C) goto 1000
         enddo
                 NZahl=0
                 Return
 1000      m=0
           Ztmp=' '
           Ztmp2=' '
           Do 900 j=1,is
           i=is-j        ! keine "+1"
               do k=1,10
               if(Zeile(i:i).eq.Z(k:k)) then
                                           m=m+1  
                                           Ztmp(m:m)=Zeile(i:i)
                                           goto 900
                                         endif
               enddo  ! do k=1,10
               goto 1001
  900      Continue
 1001      if(m.eq.0) then
                      NZahl=1 
                      Return
                      endif
* schreiben umgekehrt
           do l=1,m
             i=m-l+1    
           Ztmp2(l:l)=Ztmp(i:i)
           enddo
           Read(Ztmp2,*)Nzahl
           Return
           End
*
**************************************************************************
         Subroutine Translate1(Line)
         Character Line*80, LineG*27, LineK*27
         LineK='qwertyuiopasdfghjklzxcvbnm,'
         LineG='QWERTYUIOPASDFGHJKLZXCVBNM.'
         Do 1 i=1,80;Do 1 j=1,27
         If(line(i:i).eq.LineG(j:j)) line(i:i)=lineK(j:j)
    1    Continue
         Return
         End
*
**************************************************************************
         Subroutine fehler(j)
         Print *,'       Error number ',j
         Print *,'         (if not 0 find this number in the code !)'
         pause
         stop 
         end
*
**************************************************************************
        Subroutine ARRAYINT(KEY, E,CS,N,T,INTS0,RES)
* REAL*8
*  To get RES value for arrays E(N),CS(N) at point T depending
*  from INTS int scheme 
* KEY defines how to treat situation when T is not covered by E array
* KEY = 0   :  stop when T < E(1)  or T > E(N)
*     = 1   :  assign RES=0.0 if T < E(1) and RES=CS(N) if T > E(N)
* INT has the usual meaning as in ENDF/B format
* Input arrays E(N) and CS(N) should be in increased order
       IMPLICIT REAL*8(A-H,O-Z)
       Dimension E(N), CS(N)
       if(KEY.lt.0.or.KEY.gt.1) then
       Print *,'                        E R R O R         '
       Print *,'Subroutine  ARRAYINT:  KEY=',KEY,' is not acceptable !'
       print *,'                            press any key...'
       pause; stop;endif
       INTS=INTS0
       If(T.lt.E(1)) goto 8000;If(T.gt.E(N)) goto 9000
       Do i=1,N; i1=i; If( T.le.E(i) ) goto 1000; Enddo; goto 9500
1000   if(i1.eq.1) then  ! means that T=E(1)
       RES=CS(1);   Return; Endif       
       X1=E(i1-1); X2=E(i1);Y1=CS(i1-1); Y2=CS(i1); WL=T
       CALL INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
       RES=RESINT
       Return
8000   if(key.eq.0) then
       Write(6,*)'                        E R R O R        '
       Write(6,8001) T,E(1),key
8001   Format(1x,'Subroutine  ARRAYINT:'/1x,
     # ' Requested energy T=',e12.5,' is less than minimal array '
     # 'E(1) value=',e12.5
     #  //1x,'              CHANGE THE DATA or KEY number !!'/1x,
     # ' now  KEY is equal to', i5)
       call fehler(0); endif; RES=0.0; Print 8002,T,RES
8002   Format(1x,'ARRAYINT(N): for T =',e12.5,' result ',
     # 'is set to',e12.5,' (min)')
       Return
9000   if(key.eq.0) then
       Write(6,*)'                        E R R O R        '
       Write(6,9001) T,E(N),key
9001   Format(1x,'Subroutine  ARRAYINT:'/1x,
     # ' Requested energy T=',e12.5,' is more than MAXIMAL array '
     # 'E(N) value=',e12.5
     #  //1x,'              CHANGE THE DATA or KEY number !!'/1x,
     # ' now  KEY is equal to', i5)
       call fehler(0); endif; RES=CS(N); Print 9002,T,RES
9002   Format(1x,'ARRAYINT(X): for T =',e12.5,' result ',
     # 'is set to',e12.5,' (MAX)')
       Return
9500   Write(6,9501)
9501   Format(1x,'Subroutine  ARRAYINT:  E R R O R')
       call fehler(0)
       End
C
C***********************************************************************
           SUBROUTINE INTERMEDIATE(X1,X2,Y1,Y2,WL,INTS,RESINT)
           IMPLICIT REAL*8(A-H,O-Z)
           If(INTS.eq.1) goto 1; If(INTS.eq.2) goto 2
           If(INTS.eq.3) goto 3; If(INTS.eq.4) goto 4
           If(INTS.eq.5) goto 5
           Print *,
     #     'This interpolation scheme ',INTS,' is not supported'; Stop
1          RESINT =  Y1  
           Return
2          Call REGR1(X1,X2,Y1,Y2,AAA,BBB); RESINT =  AAA * WL + BBB 
           Return
3          aX1=dlog10(x1); aX2=dlog10(x2); aY1=y1;aY2=y2 
           aWL=dlog10(wl)
           Call REGR1(aX1,aX2,aY1,aY2,AAA,BBB)  
           RESINT =  AAA * aWL + BBB  
           Return
4          aX1=x1; aX2=x2; aY1=dlog10(y1); aY2=dlog10(y2) 
           aWL=wl
           Call REGR1(aX1,aX2,aY1,aY2,AAA,BBB)  
           RESINT = 10.**( AAA * aWL + BBB ) 
           Return
5          aX1=dlog10(x1); aX2=dlog10(x2); aY1=dlog10(y1) 
           aY2=dlog10(y2); aWL=dlog10(wl)
           Call REGR1(aX1,aX2,aY1,aY2,AAA,BBB)  
           RESINT = 10.**(   AAA * aWL + BBB  )
           Return
           End
C
C***********************************************************************
          Subroutine REGR1(x1,x2,y1,y2,a,b)                             
          IMPLICIT REAL*8(A-H,O-Z)
          Rr=x2-x1;A=(y2-y1)/rr;B=(y1*x2-x1*y2)/rr;Return                                                        
          End
*
****************************************************************************
        Subroutine Finden(Line,C500,Laenge,IPos)
        Character Line*500, C500*500; IPos=0
        Do i=1,500; i1=i
        i2=i+Laenge-1; if(i2.gt.500) Return
        if(Line(i1:i2).eq.C500(1:Laenge)) then
        IPos=i1; Return; Endif; Enddo;  Return
        End
*
**************************************************************************
       Subroutine def(E,MTlauf,CFNJ,CFEFF)
       Real*8 df,z1,a1,z2,a2,Break,EeV,dfeff
       Common/ZpApZtAtEd/Ed,IZP,IAP,IZT,IAT
       Common/oooooo/z1,a1,z2,a2
       Common/izreciarec/izrec,iarec
             Break=Ed
       If(E.eq.0.0)                                then
*
       Call Define_Residual(MTlauf, IZP,IAP, IZT,IAT, IZR,IAR)
*
c Z1, A1: "projectile", i.e. Restkern, Z2, A2: material
       z1=IZR
       a1=IAR
         z2=IZT
         a2=IAT
             EeV=0.0d0  
               izrec=izr; iarec=iar
                                                   else
* EeV in eV
             EeV=E
                                                   endif
*
       CFNJ=SNGL( df(EeV,z1,a1,z2,a2,Break,dfeff) )
*
       CFEFF=SNGL(dfeff)
       Return
       End
*
***************************************************************************
      Subroutine Define_Residual(MT,IZP,IAP, IZT,IAT, IZR,IAR)
* part of SNT code
*
* compound
        KZ=IZT + IZP
        KA=IAT + IAP
                                  IZR=KZ
                                  IAR=KA
      If(MT.eq.  2)             goto   2
      If(MT.eq.  4)             goto   4
      If(51.le.MT.and.MT.le.91) goto   4
      If(MT.eq. 16)               goto  16
      If(875.le.MT.and.MT.le.891) goto  16
      If(MT.eq. 17) goto  17
      If(MT.eq. 18) goto  18
      If(MT.eq. 22) goto  22
      If(MT.eq. 25) goto  25
      If(MT.eq. 24) goto  24
      If(MT.eq. 28) goto  28
      If(MT.eq. 29) goto  29
      If(MT.eq. 32) goto  32
      If(MT.eq. 33) goto  33
      If(MT.eq. 34) goto  34
      If(MT.eq. 37) goto  37
      If(MT.eq. 41) goto  41
      If(MT.eq.102)         Return
      If(MT.eq.103)               goto 103
      If(600.le.MT.and.MT.le.649) goto 103
      If(MT.eq.104)               goto 104
      If(650.le.MT.and.MT.le.699) goto 104
      If(MT.eq.105)               goto 105
      If(700.le.MT.and.MT.le.749) goto 105
      If(MT.eq.106)               goto 106
      If(750.le.MT.and.MT.le.799) goto 106
      If(MT.eq.107)               goto 107
      If(800.le.MT.and.MT.le.849) goto 107
      If(MT.eq.108) goto 108
      If(MT.eq.111) goto 111
      If(MT.eq.112) goto 112
        Call MT_neu(MT,KZ,KA,  IZR,IAR,iende)
                                                 if(iende.eq.0)Return
      Print 1,IZT,IAT,MT
    1 Format('Subroutine Define_Residual: IZT,IAT=',i3,i4/
     c                        ' MT number =',i5,'  is UNKNOWN !!')
      call fehler(0)
* Elastic
 2    IAR= KA - IAP
      IZR= KZ - IZP
      Return
* (X,N')
 4    IAR= KA - 1
      Return
* (X,2N)
16    IAR= KA - 2
      Return
* (X,3N)
17    IAR= KA - 3
      Return
* fission 
18    IAR= -1
      IZR=  0
      Return
* (X,NA)
22    IAR= KA - 5
      IZR= KZ - 2
      Return
* (X,2NA)
24    IAR= KA - 6
      IZR= KZ - 2
      Return
* (X,3NA)
25    IAR= KA - 7
      IZR= KZ - 2
      Return
* (X,NP)
28    IAR= KA - 2
      IZR= KZ - 1
      Return
* (X,N2A)
29    IAR= KA - 9
      IZR= KZ - 4
      Return
* (X,ND)
32    IAR= KA - 3
      IZR= KZ - 1
      Return
* (X,NT) 
33    IAR= KA - 4
      IZR= KZ - 1
      Return
* (X,N3HE)
34    IAR= KA - 4
      IZR= KZ - 2
      Return
* (X,4N)
37    IAR= KA - 4
      Return
* (X,2NP)
41    IAR= KA - 3
      IZR= KZ - 1
      Return
* (X,P)
103   IAR= KA - 1
      IZR= KZ - 1
      Return
* (X,D)
104   IAR= KA - 2
      IZR= KZ - 1
      Return
* (X,T) 
105   IAR= KA - 3
      IZR= KZ - 1
      Return
* (X,3HE)
106   IAR= KA - 3
      IZR= KZ - 2
      Return
* (X,A)
107   IAR= KA - 4
      IZR= KZ - 2
      Return
* (X,2A)
108   IAR= KA - 8
      IZR= KZ - 4
      Return
* (X,2P)
111   IAR= KA - 2
      IZR= KZ - 2
      Return
* (X,PA)
112   IAR= KA - 5
      IZR= KZ - 3
      Return
      End 
*
***************************************************************************
       Subroutine MT_neu(MT, KZ,KA, IZR,IAR,iende)
       Common/Reaktion/MTZUS(999,6)
* 1= n, 2= p, 3=d, 4=t, 5=3He, 6=a
                                        iende=1
       IA=MTZUS(mt,1)+MTZUS(mt,2)+2*MTZUS(mt,3)+3*MTZUS(mt,4)+
     c     3*MTZUS(mt,5)+4*MTZUS(mt,6)
       IZ=MTZUS(mt,2)+MTZUS(mt,3)+MTZUS(mt,4)+
     c     2*MTZUS(mt,5)+2*MTZUS(mt,6)
                                        if(IA.eq.0) Return
*
      IAR= KA - IA
      IZR= KZ - IZ
                                        iende=0
      Return
      End
*
************************************************************************
      real*8 function df(e,zr,ar,zl,al,break,dfeff)
c     ******************************************************************
c     damage function using the lindhard partition of
c     energy between atomic and electronic motion
c     call with e=0 for each reaction to precompute the constants
c     ******************************************************************
      implicit real*8 (a-h,o-z)
      common/ooo/rel, fl
      twothd=.666666667d0
      threeq=.75d0
      sixth=.166666667d0
      onep5=1.5d0
      c1=30.724d0
      c2=.0793d0
      c3=3.4008d0
      c4=.40244d0
      zero=0
c
      if (zr.eq.zero) then
         df=0
           dfeff=0.
      else if (e.le.zero) then
         el=c1*zr*zl*sqrt(zr**twothd+zl**twothd)*(ar+al)/al
         rel=1/el
         denom=(zr**twothd+zl**twothd)**threeq*ar**onep5*sqrt(al)
         fl=c2*zr**twothd*sqrt(zl)*(ar+al)**onep5/denom
         df=0
           dfeff=0.
      else if (e.lt.break) then
         df=0
           dfeff=0.
      else
         ep=e*rel
         dam=e/(1+fl*(c3*ep**sixth+c4*ep**threeq+ep))
         df=dam
c
         dfeff=dam*efficiency(zl,dam,break)
c
c
cccccccc      df=(0.8d0/(2.d0*break))*dam 
c
c
      endif
      return
      end
*
************************************************************************
      real*8 function efficiency(zl,dam,break)
      implicit real*8 (a-h,o-z)
      Common/idruck/idruck
*
      efficiency=1.0d0
*
      if(idruck.ne.3) Return       
*
      izl=idint(zl+0.0001d0)
*
*
*Fe
      If(izl.ne.26) Return
*
      efficiency=efficiency_Fe_Stoller(dam,break)
*
      Return
      End
*
************************************************************************
      real*8 function efficiency_Fe_Stoller(tdam,ed)
      implicit real*8 (a-h,o-z)                                           
c zr,ar - "recoils", zl,al - "lattice'
c
      dimension Teff(200),Eff(200)
*Fe
c Only for Fe
      Teff( 1)=3.92961E+01;   Eff( 1)=3.10464E-01 
      Teff( 2)=4.51360E+01;   Eff( 2)=3.34810E-01 
      Teff( 3)=5.08440E+01;   Eff( 3)=3.47829E-01          
      Teff( 4)=5.64302E+01;   Eff( 4)=3.56973E-01          
      Teff( 5)=6.19030E+01;   Eff( 5)=3.63730E-01          
      Teff( 6)=1.11570E+02;   Eff( 6)=4.02940E-01          
      Teff( 7)=1.54243E+02;   Eff( 7)=4.22496E-01          
      Teff( 8)=1.91764E+02;   Eff( 8)=4.34847E-01          
      Teff( 9)=2.25228E+02;   Eff( 9)=4.44354E-01          
      Teff(10)=2.55382E+02;   Eff(10)=4.52342E-01          
      Teff(11)=2.82773E+02;   Eff(11)=4.55008E-01          
      Teff(12)=3.07817E+02;   Eff(12)=4.60384E-01          
      Teff(13)=3.30842E+02;   Eff(13)=4.62952E-01          
      Teff(14)=3.52112E+02;   Eff(14)=4.66695E-01          
      Teff(15)=5.02267E+02;   Eff(15)=4.76762E-01          
      Teff(16)=5.91365E+02;   Eff(16)=4.75192E-01          
      Teff(17)=6.51587E+02;   Eff(17)=4.69268E-01          
      Teff(18)=6.95521E+02;   Eff(18)=4.67951E-01          
      Teff(19)=8.12090E+02;   Eff(19)=4.62645E-01          
      Teff(20)=8.97060E+02;   Eff(20)=4.65139E-01          
      Teff(21)=9.70010E+02;   Eff(21)=4.68211E-01          
      Teff(22)=1.00503E+03;   Eff(22)=4.82998E-01          
      Teff(23)=1.02928E+03;   Eff(23)=5.01126E-01          
      Teff(24)=1.05122E+03;   Eff(24)=5.55980E-01          
      Teff(25)=1.06306E+03;   Eff(25)=6.00856E-01          
      Teff(26)=1.07227E+03;   Eff(26)=6.99076E-01          
      Teff(27)=1.07676E+03;   Eff(27)=7.77360E-01          
      Teff(28)=1.07962E+03;   Eff(28)=8.63651E-01          
      Teff(29)=1.08168E+03;   Eff(29)=9.42473E-01          
      Teff(30)=1.00000E+10;   Eff(30)=9.42473E-01          
c
      Nmax=30
c
      efficiency_Fe_Stoller=1.d+00
c
      eMD=tdam/1000.   ! eV --> keV
c   
c Iron  (Stoller)
                             If(ed.ne.40.0d0) goto 90000
      if(eMD.le.40.0) then
      efficiency_Fe_Stoller=0.5608*(eMD**(-0.3029))+3.227e-03*eMD
                      else
      Call ARRAYINT(0, Teff, Eff,Nmax, eMD, 2, result)
      efficiency_Fe_Stoller=result
                      endif
      return                         
c
90000 Write(*,90001) ed
90001 Format(' E R R O R !'/1x,'ed=',f8.2,' is not correct for Fe '/)
      call fehler(0)
      end                                                                 
